package edu.washington.cs.atomicdebug.examples;

/**
 * This program creates two threads, both of which have access to a variable i.
 * They then each try to increment i five times and print its new value each
 * time. Not the most practical program, but it demonstrates some of the odd
 * behavior race conditions may cause.
 * 
 * @author Laura Effinger-Dean
 */
public class TwoThreads extends Thread {
	static int i = 0;

	public void run() {
		for (int j = 0; j < 5; j++) {

			i++;
			System.out.println(getName() + ": " + i);
		}
	}

	public static void main(String[] args) {
		TwoThreads t1 = new TwoThreads();
		TwoThreads t2 = new TwoThreads();
		t1.start();
		t2.start();
	}
}